unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine,
  VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    chrtSavingsNeeded: TChart;
    Series1: TBarSeries;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    procedure AddSEriesValue(const aValue: double; const aCaption: string; const aCurrent: boolean);
    procedure CreateImage(aChart: TChart);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.CreateImage(aChart: TChart);
var
  lHoldShadow: boolean;
  I: Integer;
  lBoolArray: array of boolean;
  lHoldBevel: TBevelCut;
  lHoldColor: TColor;
  lHoldGradientVisible: boolean;
  lMetafile: TMetafile;
  lBmp: TBitmap;
begin
  lHoldGradientVisible := aChart.Gradient.Visible;
  lHoldColor := aChart.Color;
  lHoldBevel := aChart.BevelOuter;
  lHoldShadow := aChart.Shadow.Visible;

  try
    SetLength(lBoolArray, aChart.SeriesCount);
    for I := 0 to aChart.SeriesCount - 1 do    // Iterate
      if aChart.Series[I] is TPieSeries then
      begin
        lBoolArray[I] := TPieSeries(aChart.Series[I]).Circled;
        TPieSeries(aChart.Series[I]).Circled := True;
      end
      else
        lBoolArray[I] := True;


    aChart.Gradient.Visible  := false;
//    if not aTransparent then
//      aChart.Color := clWhite
//    else
      aChart.Color := clNone; //clWhite;
    aChart.BevelOuter := bvNone;
    aChart.BevelInner := bvNone;
    aChart.Shadow.Visible := False;

    lBmp := aChart.TeeCreateBitmap(clWhite, Rect(1, 1, 463, 248));
    try
      Image1.Picture.Graphic := lbmp;
    finally
      lBmp.Free;
    end;
  finally
    aChart.Shadow.Visible := lHoldShadow;
    aChart.Gradient.Visible := lHoldGradientVisible;
    aChart.Color := lHoldColor;
    aChart.BevelOuter := lHoldBevel;
    for I := 0 to aChart.SeriesCount - 1 do    // Iterate
      if aChart.Series[I] is TPieSeries then
        TPieSeries(aChart.Series[I]).Circled := lBoolArray[I];
  end;
end;

procedure TForm1.AddSEriesValue(const aValue: double; const aCaption: string;
  const aCurrent: boolean);
var
  lCaption: string;
begin
  lCaption := aCaption + #13;
  if aCurrent then
    lCaption := lCaption + '(Current)'#13;
  lCaption := lCaption + Format('%.0m', [aValue]);

  Series1.Add(aValue, lCaption, clTeeColor);

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Series1.Clear;
  AddSeriesValue(1000, 'Maximum Lifetime Benefit', True);

  CreateImage(chrtSavingsNeeded);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Series1.Clear;
  AddSeriesValue(18283, '3.00%', false);
  AddSeriesValue(17274, '3.50%', false);
  AddSeriesValue(16378, '4.00%', true);
  AddSeriesValue(15565, '4.50%', false);
  AddSeriesValue(14825, '5.00%', false);

  CreateImage(chrtSavingsNeeded);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Series1.Clear;
  AddSeriesValue(28634, '2%', false);
  AddSeriesValue(31128, '2.5%', false);
  AddSeriesValue(33880, '3%', true);
  AddSeriesValue(36919, '3.5%', false);
  AddSeriesValue(43216, '4%', false);

  CreateImage(chrtSavingsNeeded);
end;


end.
